#include <apr/pool.hh>
#include <apr/exception.hh>
#include <apr_pools.h>

namespace apr {

Pool::Pool() : owner(true) {
    Exception::handle(apr_pool_create(&me, NULL));
}

Pool::Pool(Pool &parent) : owner(true) {
    Exception::handle(apr_pool_create(&me, parent));
}

Pool::~Pool() {
    if (me != 0 && owner) {
        apr_pool_destroy(me);
    }
}

void Pool::clear() {
    apr_pool_clear(me);
}

Pool::operator apr_pool_t *const () const {
    return me;
}

}
