#ifndef SVN_RA_CALLBACKS_HH
#define SVN_RA_CALLBACKS_HH

#include <apr/file.hh>
#include <boost/utility.hpp>
#include <boost/function/function0.hpp>
#include <svn_ra.h>

namespace svn {
namespace ra {

class Callbacks : private boost::noncopyable {
        friend class Session;

    public:
        void setOpenTmpFile(const boost::function0<apr::File> &newOtf)
            { openTmpFile = newOtf; }

    private:
        static svn_error_t *open_tmp_file(apr_file_t **fp,
                void *callback_baton);
        static svn_error_t *get_authenticator(void **authenticator,
                void **auth_baton, enum svn_ra_auth_method method,
                void *callback_baton, apr_pool_t *pool);
        static svn_error_t *get_wc_prop(void *baton, const char *relpath,
                const char *name, const svn_string_t **value, apr_pool_t *pool);
        static svn_error_t *set_wc_prop(void *baton, const char *path,
                const char *name, const svn_string_t *value, apr_pool_t *pool);
        static svn_error_t *push_wc_prop(void *baton, const char *path,
                const char *name, const svn_string_t *value, apr_pool_t *pool);
        static svn_error_t *invalidate_wc_props(void *baton, const char *path,
                const char *name, apr_pool_t *pool);

        boost::function0<apr::File> openTmpFile;

    protected:
        static svn_ra_callbacks_t rawCallbacks;
};

}
}

#endif
