#include <svn/ra/session.hh>
#include <svn/exception.hh>
#include <svn/ra/library.hh>
#include <svn/ra/callbacks.hh>
#include <svn/pool.hh>

namespace svn {
namespace ra {

Session::Session(Library &l, const std::string &url, const Callbacks &c,
        Pool &p) : library(l) {
    Exception::handle(library.me->open(&me, url.c_str(),
                &c.rawCallbacks, (void*) &c, p));
}

Session::~Session() {
    Exception::handle(library.me->close(me));
}

RevisionNumber Session::getLatestRevision() {
    svn_revnum_t r;
    Exception::handle(library.me->get_latest_revnum(me, &r));
    return r;
}

}
}
