#ifndef SVN_RA_SESSION_HH
#define SVN_RA_SESSION_HH

#include <boost/utility.hpp>
#include <svn/types.hh>
#include <string>

namespace svn {

class Pool;

namespace ra {

class Library;
class Callbacks;

/**
 * A session for accessing a specific remote repository.
 **/
class Session : private boost::noncopyable {
    public:
        Session(Library &l, const std::string &url, const Callbacks &callbacks,
                Pool &p);
        ~Session();

        RevisionNumber getLatestRevision();
    private:
        Library &library;
        void *me;
};

}
}

#endif
